pro annotateheader, h, keywords, comments, overwrite=overwrite

  ; Adding missing comments to a header.  Doesn't overwrite unless specified.

  for k = 0, n_elements(keywords)-1 do begin
     if comments[k] eq '' then continue
     info = sxpar(h,keywords[k],comment=comment, count=ct, /silent)
     if ct eq 0 then continue
     if keyword_set(overwrite) eq 0 and clip(comment) ne '' then continue

     sxaddpar, h, keywords[k], info, ' '+comments[k]
  endfor

end

