pro reorderheader, h, newkeywordorder
  n = n_elements(h)

  keys = strarr(n)
  for i = 0, n-1 do begin
     eqpos = strpos(h[i],'=')
     if eqpos lt 0 then continue
     keys[i] = clip(strmid(h[i],0,eqpos))
  endfor

  i = 0
  neworder = lonarr(n)-1
  for j = 0, n_elements(newkeywordorder)-1 do begin
     w = where(newkeywordorder[j] eq keys, ct)
     for t = 0, ct-1 do begin
       neworder[i] = w[t]
       i += 1
     endfor
  endfor
  ;neworder = neworder[0:j-1]

  ; neworder: value of the ith element gives the position in the new list
  ; e.g. value j of i=0th element tells you position j where the i=0th member of h goes in new list.
  ; KEY has position i=0 in old list and j in new list:
  ; neworder[i] = j
  ; where(neworder==j) = i
  ; oldkeys[i] = 'KEY'
  ; newkeys[j] = 'KEY'

  ; put all unassigned keywords at the end
  for i = 0, n-1 do begin
     if neworder[i] eq -1 then begin
       vv = neworder[where(neworder ge 0)]
       nextunassigned = (where(indgen(n_elements(vv)) ne vv[sort(vv)])) [0]
       if nextunassigned lt 0 then nextunassigned = n_elements(vv)
       neworder[i] = nextunassigned
       ;j += 1
     endif
  endfor

  ;print, n_elements(neworder), ' / ', n_elements(unique(neworder))

  hout = h[neworder]
  h = hout

end

