function percentile, arr, pct, interpolate=interpolate
  sortarr = (arr[sort(arr)]) [*]
  n = n_elements(arr)
  if keyword_set(interpolate) eq 0 then begin
     pos = long(n * pct/100.)
     if pos ge n then pos = n-1
     return, sortarr[pos]
  endif else begin
     apc = 100*(0.5+findgen(n_elements(arr)))/n_elements(arr)
     out = interpol(sortarr, apc, pct)
     return, out
  endelse

end

