; An INCOMPLETE program to attempt to construct slit flats.
; Does not work / do not use.  Kept in case some of the code is useful for a future slit-correction routine.
; 
; Assumes the source extension is present (it isn't anymore) and generally does not do a great job (noisy).
; Could do a lot better with use of tracing function.

pro makeslitflatone, sfile, outimage=outimage

  im = readfits(sfile, h, /silent)
  sky = mrdfits(sfile, 1, hsky, /silent)
  src = mrdfits(sfile, 2, hsrc, /silent)

  dim = im-src+sky

  s = size(dim)
  nx = s[1]
  ny = s[2]
 

  issky = sky gt median(sky)*7 ; could do this more locally
  nsky = intarr(nx)
  for x = 0, nx-1 do begin
     nsky[x] = total(issky[x,*])
  endfor
  skyfree = nsky eq 0

  blockinc = 5
  edgebuff = 5 ; buffer from left and right edges
  nxblocks = nx/blockinc ; do this every every pix
  fy = fltarr(nxblocks, ny)+!values.f_nan
  for b = 0, nxblocks-1 do begin
    xc = b*(nx/nxblocks)
    x0 = (xc - 200) > edgebuff ; avoid the edges
    x1 = (xc + 200) < (nx-edgebuff)
    ;while (skyfree[x0] eq 0 and x0 gt edgebuff) do x0 -= 1
    ;while (skyfree[x1] eq 0 and x1 lt nx-edgebuff) do x1 += 1

    ;while (skyfree[x0] eq 0 and x0 gt edgebuff) do x0 -= 1
    ;while (skyfree[x1] eq 0 and x1 lt nx-edgebuff) do x1 += 1

    while 1 do begin
       xx = x0 + indgen(x1-x0+1)
       wsky = where(nsky[xx] ge 10, ctxsky)
       if ctxsky gt 10 then begin
          ; we have enough sky lines, but expand a bit more to make sure 
          ; we're not drawing the edge through the middle of one
          while (skyfree[x0] eq 0 and x0 gt edgebuff) do x0 -= 1
          while (skyfree[x1] eq 0 and x1 lt nx-edgebuff) do x1 += 1
            ; at this point we have enough sky and are not on a line, so we're done
          break
       endif else begin
          ; not enough sky lines, expand by a large increment and try again
          x0 = (x0-blockinc) > edgebuff   ; =every avoids oscillating behavior
          x1 = (x1+blockinc) < (nx-edgebuff)
       endelse
    endwhile

   ; print, xc, ':', x0, x1, ctxsky
    for y = 0, ny-1 do begin
      xxsky = xx[wsky]  ; but we want to avoid a sky line being on the edges
      fy[b,y] = total(dim[xxsky,y]) ; could use a median/rejection alg but this works?
    endfor

  endfor
  for x = 0, nxblocks-1 do begin
     fy[x,*] = fy[x,*] / median(fy[x,*],/even)
     y = findgen(ny)
     w = where(finite(fy[x,*])) ; note that actually y[w] = w
     p = poly_fit(y[w], fy[x,w], 4, yfit=yfit)
     fy[x,w] /= yfit
  endfor
  
  outimage = congrid(fy, nx, ny, /interp)

  ; writefits, 'outimage.fits', outimage

end

pro makeslitflat, sfiles

  h = headfits(sfiles[0])
  nx = sxpar(h,'NAXIS1')
  ny = sxpar(h,'NAXIS2')
  ; make a stack
  ; run makeslitflat on each individual element
  ; 

end

pro slitcorrectself, filename
  ; use the sky lines to correct an image that's already been background subtracted

  makeslitflatone, filename, outimage=slitflat

  ; just do this all again, whatever
  im = readfits(filename, h, /silent)
  sky = mrdfits(filename, 1, hsky, /silent)
  src = mrdfits(filename, 2, hsrc, /silent)

  expectedresidual = sky*slitflat - sky
  correctim = im - expectedresidual
  ; do we want to (reverse-)correct the sky too, to retain  sky+im = "true" ?

  outfile = 'sfix'+removepath(filename)
  writefits, outfile, correctim, h ;, /quiet
  mwrfits, sky, outfile, hsky, /silent
  mwrfits, src, outfile, hsrc, /silent

  ;writefits, 'q_expectedresidual.fits', expectedresidual, h
  ;writefits, 'q_correctim.fits', correctim, h
end

